Index: apps/app_dial.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_dial.c,v
retrieving revision 1.129
diff -u -r1.129 app_dial.c
--- apps/app_dial.c	18 Jan 2005 16:47:33 -0000	1.129
+++ apps/app_dial.c	19 Jan 2005 20:35:34 -0000
@@ -62,7 +62,8 @@
 "The option string may contain zero or more of the following characters:\n"
 "      'd' -- allow the calling user to dial a 1 digit extension while waiting for a call to\n"
 "             be answered exiting to that extension if it exists in the context defined by\n"
-"             ${EXITCONTEXT} or the current context.\n"
+"             ${EXITCONTEXT} or the current context. if ${EXITCONTEXT} is equal to 'disabled'\n"
+"             then the feature is disabled\n"
 "      't' -- allow the called user to transfer the calling user by hitting #.\n"
 "      'T' -- allow the calling user to transfer the call by hitting #.\n"
 "      'w' -- allow the called user to write the conversation to disk via app_monitor\n"
@@ -124,7 +125,8 @@
 "'loops' the call will continue in the dialplan.  If 'loops' is set to 0, the call will retry endlessly.\n\n"
 "While waiting, a 1 digit extension may be dialed.  If that extension exists in either\n"
 "the context defined in ${EXITCONTEXT} or the current one, The call will transfer\n"
-"to that extension immmediately.\n\n"
+"to that extension immmediately. if ${EXITCONTEXT} is equal to 'disabled' then the\n"
+"feature is disabled\n\n"
 "All arguements after 'loops' are passed directly to the Dial() application.\n"
 "";
 
@@ -235,7 +237,13 @@
 	int single;
 	struct ast_channel *winner;
 	char *context = NULL;
+	struct ast_flags myflags;
 
+	myflags = *peerflags;
+	context = pbx_builtin_getvar_helper(in, "EXITCONTEXT");
+	if(context && !strcasecmp(context, "DISABLED"))
+		ast_clear_flag(&myflags, DIAL_HALT_ON_DTMF);
+	
 	single = (outgoing && !outgoing->next && !ast_test_flag(outgoing, DIAL_MUSICONHOLD | DIAL_RINGBACKONLY));
 	
 	if (single) {
@@ -499,8 +507,7 @@
 			}
 
 			if (f && (f->frametype == AST_FRAME_DTMF)) {
-				if (ast_test_flag(peerflags, DIAL_HALT_ON_DTMF)) {
-					context = pbx_builtin_getvar_helper(in, "EXITCONTEXT");
+				if (ast_test_flag(&myflags, DIAL_HALT_ON_DTMF)) {
 					if (ast_onedigit_goto(in, context, (char) f->subclass, 1, in->cid.cid_num)) {
 						if (option_verbose > 3)
 							ast_verbose(VERBOSE_PREFIX_3 "User hit %c to disconnect call.\n", f->subclass);
@@ -1255,6 +1262,9 @@
 	
 	memset(&peerflags, 0, sizeof(peerflags));
 
+	ast_set_flag(&peerflags, DIAL_HALT_ON_DTMF);
+	
+
 	LOCAL_USER_ADD(u);
 	
 	if (!data || !(announce = ast_strdupa(data))) {
@@ -1300,7 +1310,9 @@
 		loops = -1;
 	
 	context = pbx_builtin_getvar_helper(chan, "EXITCONTEXT");
-	
+	if(context && !strcasecmp(context, "DISABLED"))
+	   ast_clear_flag(&peerflags, DIAL_HALT_ON_DTMF);
+	   
 	while (loops) {
 		chan->data = "Retrying";
 		if (ast_test_flag(chan, AST_FLAG_MOH))
@@ -1318,7 +1330,9 @@
 			} else {
 				if (!(res = ast_streamfile(chan, announce, chan->language)))
 					res = ast_waitstream(chan, "");
-				if (!res) 
+				if (!ast_test_flag(chan, AST_FLAG_MOH))
+					ast_moh_start(chan, NULL);
+				if (!res)
 					res = ast_safe_sleep(chan, sleep);
 			}
 		}
